package server;

import org.omg.PortableServer.*;
import shopping.*;
import java.util.*;

public class ShoppingCartFactoryImpl extends ShoppingCartFactoryPOA {

  private Dictionary allCarts = new Hashtable();
	
	public synchronized ShoppingCart getShoppingCart(String userID) {

    // Cerca il carrello assegnato allo userID...
    shopping.ShoppingCart cart = (shopping.ShoppingCart) allCarts.get(userID);

    // ...se non lo trova...
    if(cart == null) {
      
      // Crea un nuovo carrello...
      ShoppingCartImpl cartServant = new ShoppingCartImpl();

			try {
				
	      // Attiva l'oggetto sul default POA che  il root POA di questo servant
  	    cart = shopping.ShoppingCartHelper.narrow(_default_POA().servant_to_reference(cartServant));
      
      } catch (Exception e) {
        e.printStackTrace();
      }

      System.out.println("Created " + userID + "'s cart: " + cart);
      
      // Salva il carrello nel dictionary associandolo allo userID
      allCarts.put(userID, cart);
    }

    // Restituisce il carrello
    return cart;
	}
}
